diff -ruN ../nakedmudv3.7.9/lib/pymodules/cmd_manip.py lib/pymodules/cmd_manip.py
--- ../nakedmudv3.7.9/lib/pymodules/cmd_manip.py	2009-03-02 02:02:41.000000000 -0500
+++ lib/pymodules/cmd_manip.py	2009-04-05 14:29:14.000000000 -0400
@@ -1,29 +1,24 @@
-################################################################################
-#
-# cmd_manip.py
-#
-# a set of commands that NakedMud(tm) comes with that allows characters to
-# manipulate various things. These commands are mostly directed towards
-# manipulating objects (e.g. get, put, drop, etc...) but can also affect other
-# things like exits (e.g. open, close)
-#
-################################################################################
-from mud import *
-from utils import *
-from inform import *
-from mudsys import add_cmd, add_cmd_check
-import movement, hooks
+'''
+cmd_manip.py
+
+a set of commands that NakedMud(tm) comes with that allows characters to
+manipulate various things. These commands are mostly directed towards
+manipulating objects (e.g. get, put, drop, etc...) but can also affect other
+things like exits (e.g. open, close)
+'''
+import mudsys, mud, inform, utils, movement, hooks
+import obj as mudobj
 
 
 
 def do_give(ch, recv, obj):
     '''does the handling of the give command'''
-    message(ch, recv, obj, None, True, "to_room",
-            "$n gives $o to $N.")
-    message(ch, recv, obj, None, True, "to_vict",
-            "$n gives $o to you.")
-    message(ch, recv, obj, None, True, "to_char",
-            "You give $o to $N.")
+    mud.message(ch, recv, obj, None, True, "to_room",
+                "$n gives $o to $N.")
+    mud.message(ch, recv, obj, None, True, "to_vict",
+                "$n gives $o to you.")
+    mud.message(ch, recv, obj, None, True, "to_char",
+                "You give $o to $N.")
     obj.carrier = recv
 
     # run our give hook
@@ -45,9 +40,9 @@
 
        > give 3.cookie george'''
     try:
-        to_give, multi, recv = parse_args(ch, True, cmd, arg,
-                                          "[the] obj.inv.multiple " +
-                                          "[to] ch.room.noself")
+        to_give, multi, recv = mud.parse_args(ch, True, cmd, arg,
+                                              "[the] obj.inv.multiple " +
+                                              "[to] ch.room.noself")
     except: return
 
     if multi == False:
@@ -58,16 +53,16 @@
 
 def do_get(ch, obj, cont):
     '''transfers an item from the ground to the character'''
-    if is_keyword(obj.bits, "notake"):
+    if utils.is_keyword(obj.bits, "notake"):
         ch.send("You cannot take " + ch.see_as(obj) + ".")
     elif cont != None:
         obj.carrier = ch
-        message(ch, None, obj, cont, True, "to_char", "You get $o from $O.")
-        message(ch, None, obj, cont, True, "to_room", "$n gets $o from $O.")
+        mud.message(ch, None, obj, cont, True, "to_char", "You get $o from $O.")
+        mud.message(ch, None, obj, cont, True, "to_room", "$n gets $o from $O.")
     else:
         obj.carrier = ch
-        message(ch, None, obj, None, True, "to_char", "You get $o.")
-        message(ch, None, obj, None, True, "to_room", "$n gets $o.")
+        mud.message(ch, None, obj, None, True, "to_char", "You get $o.")
+        mud.message(ch, None, obj, None, True, "to_room", "$n gets $o.")
 
         # run get hooks
         hooks.run("get", hooks.build_info("ch obj", (ch, obj)))
@@ -75,16 +70,17 @@
 def try_get_from(ch, cont, arg):
     '''tries to get one item from inside another'''
     if not cont.istype("container"):
-        message(ch, None, cont, None, True, "to_char", "$o is not a container.")
+        mud.message(ch, None, cont, None, True, "to_char",
+                    "$o is not a container.")
     elif cont.container_is_closed:
-        message(ch, None, cont, None, True, "to_char", "$o is closed.")
+        mud.message(ch, None, cont, None, True, "to_char", "$o is closed.")
     else:
         # find our count and name
-        num, name = get_count(arg)
+        num, name = utils.get_count(arg)
 
         # multi or single?
         if num == "all":
-            list = find_all_objs(ch, cont.objs, name)
+            list = utils.find_all_objs(ch, cont.objs, name)
             for obj in list:
                 do_get(ch, obj, cont)
         else:
@@ -93,8 +89,8 @@
             if obj != None:
                 do_get(ch, obj, cont)
             else:
-                message(ch, None, cont, None, True, "to_char",
-                        "You could not find what you were looking for in $o.")
+                mud.message(ch, None, cont, None, True, "to_char",
+                            "You could not find what you were looking for in $o.")
 
 def cmd_get(ch, cmd, arg):
     '''Usage: get [the] <item> [[from] <other item>]
@@ -103,8 +99,8 @@
        addition argument is supplied, the command assumes it is a container and
        instead tries to move an object from the container to your inventory.'''
     try:
-        arg, cont = parse_args(ch, True, cmd, arg,
-                               "[the] word(object) | [from] obj.room.inv.eq")
+        arg,cont = mud.parse_args(ch, True, cmd, arg,
+                                  "[the] word(object) | [from] obj.room.inv.eq")
     except: return
     
     # are we doing get, or get-from?
@@ -113,7 +109,7 @@
     else:
         # try to find the object in the room
         try:
-            found, multi = parse_args(ch, True, cmd, arg, "obj.room.multiple")
+            found,multi= mud.parse_args(ch, True, cmd, arg, "obj.room.multiple")
         except: return
 
         # pick up all the items we want
@@ -127,8 +123,8 @@
     '''handles object dropping'''
     obj.room = ch.room
 
-    message(ch, None, obj, None, True, "to_char", "You drop $o.")
-    message(ch, None, obj, None, True, "to_room", "$n drops $o.")
+    mud.message(ch, None, obj, None, True, "to_char", "You drop $o.")
+    mud.message(ch, None, obj, None, True, "to_room", "$n drops $o.")
 
     # run our drop hook
     hooks.run("drop", hooks.build_info("ch obj", (ch, obj)))
@@ -138,7 +134,7 @@
 
        Attempts to move an object from your inventory to the ground.'''
     try:
-        found, multi = parse_args(ch, True, cmd, arg, "[the] obj.inv.multiple")
+        found,multi=mud.parse_args(ch, True, cmd, arg, "[the] obj.inv.multiple")
     except: return
 
     # are we dropping a list of things, or just one?
@@ -157,8 +153,8 @@
     if obj.carrier != ch:
         ch.send("You were unable to remove " + ch.see_as(obj) + ".")
     else:
-        message(ch, None, obj, None, True, "to_char", "You remove $o.")
-        message(ch, None, obj, None, True, "to_room", "$n removes $o.")
+        mud.message(ch, None, obj, None, True, "to_char", "You remove $o.")
+        mud.message(ch, None, obj, None, True, "to_room", "$n removes $o.")
 
         # run our hooks
         hooks.run("remove", hooks.build_info("ch obj", (ch, obj)))
@@ -181,7 +177,7 @@
 
        > remove 2.ring'''
     try:
-        found, multi = parse_args(ch, True, cmd, arg, "[the] obj.eq.multiple")
+        found,multi= mud.parse_args(ch, True, cmd, arg, "[the] obj.eq.multiple")
     except: return
 
     # are we removing one thing, or multiple things?
@@ -197,8 +193,8 @@
         ch.send("But " + ch.see_as(obj) + " is not equippable.")
         
     elif ch.equip(obj, where):
-        message(ch, None, obj, None, True, "to_char", "You wear $o.")
-        message(ch, None, obj, None, True, "to_room", "$n wears $o.")
+        mud.message(ch, None, obj, None, True, "to_char", "You wear $o.")
+        mud.message(ch, None, obj, None, True, "to_room", "$n wears $o.")
 
         # run our wear hook
         hooks.run("wear", hooks.build_info("ch obj", (ch, obj)))
@@ -218,8 +214,8 @@
 
        > wear gloves left hand, right hand'''
     try:
-        found, multi, where = parse_args(ch, True, cmd, arg,
-                                         "[the] obj.inv.multiple | [on] string(bodyparts)")
+        found, multi, where = mud.parse_args(ch, True, cmd, arg,
+                                             "[the] obj.inv.multiple | [on] string(bodyparts)")
     except: return
 
     # Are the things we're looking for not body positions? Try to catch this!
@@ -230,7 +226,7 @@
         if not where in ch.bodyparts:
             where = None
             try:
-                found, = parse_args(ch,True,cmd,"'"+arg+"'","[the] obj.inv")
+                found, = mud.parse_args(ch,True,cmd,"'"+arg+"'","[the] obj.inv")
             except: return
 
     # are we wearing one thing, or multiple things?
@@ -251,8 +247,8 @@
     # do the move
     else:
         obj.container = cont
-        message(ch, None, obj, cont, True, "to_char", "You put $o in $O.")
-        message(ch, None, obj, cont, True, "to_room", "$n puts $o in $O.")
+        mud.message(ch, None, obj, cont, True, "to_char", "You put $o in $O.")
+        mud.message(ch, None, obj, cont, True, "to_room", "$n puts $o in $O.")
 
 def cmd_put(ch, cmd, arg):
     '''Usage: put [the] <item> [in the] <container>
@@ -261,9 +257,9 @@
        container. The container must be in the room, in your inventory, or
        worn.'''
     try:
-        found, multi, cont = parse_args(ch, True, cmd, arg,
-                                        "[the] obj.inv.multiple " +
-                                        "[in] [the] obj.room.inv")
+        found, multi, cont = mud.parse_args(ch, True, cmd, arg,
+                                            "[the] obj.inv.multiple " +
+                                            "[in] [the] obj.room.inv")
     except: return
 
     # make sure we have a container
@@ -330,8 +326,8 @@
 
        Attempts to lock a specified door, direction, or container.'''
     try:
-        found, type = parse_args(ch, True, cmd, arg,
-                                 "[the] {obj.room.inv.eq exit }")
+        found, type = mud.parse_args(ch, True, cmd, arg,
+                                     "[the] {obj.room.inv.eq exit }")
     except: return
 
     # what did we find?
@@ -350,10 +346,10 @@
         elif not has_proto(ch, ex.key):
             ch.send("You cannot seem to find the key.")
         else:
-            message(ch, None, None, None, True, "to_char",
-                    "You lock " + name + ".")
-            message(ch, None, None, None, True, "to_room",
-                    "$n locks " + name + ".")
+            mud.message(ch, None, None, None, True, "to_char",
+                        "You lock " + name + ".")
+            mud.message(ch, None, None, None, True, "to_room",
+                        "$n locks " + name + ".")
             ex.lock()
             # hooks.run("room_change", hooks.build_info("rm", (ch.room, )))
             try_manip_other_exit(ch.room, ex, ex.is_closed, True)
@@ -372,8 +368,8 @@
         elif not has_proto(ch, obj.container_key):
             ch.send("You cannot seem to find the key.")
         else:
-            message(ch, None, obj, None, True, "to_char", "You lock $o.")
-            message(ch, None, obj, None, True, "to_room", "$n locks $o.")
+            mud.message(ch, None, obj, None, True, "to_char", "You lock $o.")
+            mud.message(ch, None, obj, None, True, "to_room", "$n locks $o.")
             obj.container_is_locked = True
 
 def cmd_unlock(ch, cmd, arg):
@@ -381,7 +377,7 @@
 
        Attempts to unlock the specified door, direction, or container.'''
     try:
-        found, type = parse_args(ch, True,cmd,arg, "[the] {obj.room.inv exit }")
+        found,type=mud.parse_args(ch,True,cmd,arg, "[the] {obj.room.inv exit }")
     except: return
 
     # what did we find?
@@ -401,10 +397,10 @@
         elif not has_proto(ch, ex.key):
             ch.send("You cannot seem to find the key.")
         else:
-            message(ch, None, None, None, True, "to_char",
-                    "You unlock " + name + ".")
-            message(ch, None, None, None, True, "to_room",
-                    "$n unlocks " + name + ".")
+            mud.message(ch, None, None, None, True, "to_char",
+                        "You unlock " + name + ".")
+            mud.message(ch, None, None, None, True, "to_room",
+                        "$n unlocks " + name + ".")
             ex.unlock()
             # hooks.run("room_change", hooks.build_info("rm", (ch.room, )))
             try_manip_other_exit(ch.room, ex, ex.is_closed, False)
@@ -423,8 +419,8 @@
         elif not has_proto(ch, obj.container_key):
             ch.send("You cannot seem to find the key.")
         else:
-            message(ch, None, obj, None, True, "to_char", "You unlock $o.")
-            message(ch, None, obj, None, True, "to_room", "$n unlocks $o.")
+            mud.message(ch, None, obj, None, True, "to_char", "You unlock $o.")
+            mud.message(ch, None, obj, None, True, "to_room", "$n unlocks $o.")
             obj.container_is_locked = False
 
 def cmd_open(ch, cmd, arg):
@@ -432,7 +428,7 @@
 
        Attempts to open the speficied door, direction, or container.'''
     try:
-        found, type = parse_args(ch, True,cmd,arg, "[the] {obj.room.inv exit }")
+        found,type=mud.parse_args(ch,True,cmd,arg, "[the] {obj.room.inv exit }")
     except: return
 
     # is it an exit?
@@ -449,10 +445,10 @@
         elif not ex.is_closable:
             ch.send(name + " cannot be opened.")
         else:
-            message(ch, None, None, None, True, "to_char",
-                    "You open " + name + ".")
-            message(ch, None, None, None, True, "to_room",
-                    "$n opens " + name + ".")
+            mud.message(ch, None, None, None, True, "to_char",
+                        "You open " + name + ".")
+            mud.message(ch, None, None, None, True, "to_room",
+                        "$n opens " + name + ".")
             ex.open()
             # hooks.run("room_change", hooks.build_info("rm", (ch.room, )))
             try_manip_other_exit(ch.room, ex, False, ex.is_locked)
@@ -470,8 +466,8 @@
         elif not obj.container_is_closable:
             ch.send(ch.see_as(obj) + " cannot be opened.")
         else:
-            message(ch, None, obj, None, True, "to_char", "You open $o.")
-            message(ch, None, obj, None, True, "to_room", "$n opens $o.")
+            mud.message(ch, None, obj, None, True, "to_char", "You open $o.")
+            mud.message(ch, None, obj, None, True, "to_room", "$n opens $o.")
             obj.container_is_closed = False
             hooks.run("open_obj", hooks.build_info("ch obj", (ch, obj)))
 
@@ -480,7 +476,7 @@
 
        Attempts to close the specified door, direction, or container.'''
     try:
-        found, type = parse_args(ch, True,cmd,arg, "[the] {obj.room.inv exit }")
+        found,type=mud.parse_args(ch,True,cmd,arg, "[the] {obj.room.inv exit }")
     except: return
 
     # is it an exit?
@@ -497,10 +493,10 @@
         elif not ex.is_closable:
             ch.send(name + " cannot be closed.")
         else:
-            message(ch, None, None, None, True, "to_char",
-                    "You close " + name + ".")
-            message(ch, None, None, None, True, "to_room",
-                    "$n closes " + name + ".")
+            mud.message(ch, None, None, None, True, "to_char",
+                        "You close " + name + ".")
+            mud.message(ch, None, None, None, True, "to_room",
+                        "$n closes " + name + ".")
             ex.close()
             # hooks.run("room_change", hooks.build_info("rm", (ch.room, )))
             try_manip_other_exit(ch.room, ex, True, ex.is_locked) 
@@ -516,8 +512,8 @@
         elif not obj.container_is_closable:
             ch.send(ch.see_as(obj) + " cannot be closed.")
         else:
-            message(ch, None, obj, None, True, "to_char", "You close $o.")
-            message(ch, None, obj, None, True, "to_room", "$n closes $o.")
+            mud.message(ch, None, obj, None, True, "to_char", "You close $o.")
+            mud.message(ch, None, obj, None, True, "to_room", "$n closes $o.")
             obj.container_is_closed = True
             hooks.run("close_obj", hooks.build_info("ch obj", (ch, obj)))
 
@@ -526,16 +522,16 @@
 ################################################################################
 # load all of our commands
 ################################################################################
-add_cmd("give",   None, cmd_give,   "player", True)
-add_cmd("get",    None, cmd_get,    "player", True)
-add_cmd("drop",   None, cmd_drop,   "player", True)
-add_cmd("remove", None, cmd_remove, "player", True)
-add_cmd("wear",   None, cmd_wear,   "player", True)
-add_cmd("put",    None, cmd_put,    "player", True)
-add_cmd("open",   None, cmd_open,   "player", True)
-add_cmd("close",  None, cmd_close,  "player", True)
-add_cmd("lock",   None, cmd_lock,   "player", True)
-add_cmd("unlock", None, cmd_unlock, "player", True)
+mudsys.add_cmd("give",   None, cmd_give,   "player", True)
+mudsys.add_cmd("get",    None, cmd_get,    "player", True)
+mudsys.add_cmd("drop",   None, cmd_drop,   "player", True)
+mudsys.add_cmd("remove", None, cmd_remove, "player", True)
+mudsys.add_cmd("wear",   None, cmd_wear,   "player", True)
+mudsys.add_cmd("put",    None, cmd_put,    "player", True)
+mudsys.add_cmd("open",   None, cmd_open,   "player", True)
+mudsys.add_cmd("close",  None, cmd_close,  "player", True)
+mudsys.add_cmd("lock",   None, cmd_lock,   "player", True)
+mudsys.add_cmd("unlock", None, cmd_unlock, "player", True)
 
 def chk_can_manip(ch, cmd):
     if not ch.pos in ["sitting", "standing", "flying"]:
@@ -544,5 +540,4 @@
 
 for cmd in ["give", "get", "drop", "remove", "wear", "put", "open", "close",
             "lock", "unlock"]:
-    add_cmd_check(cmd, chk_can_manip)
-    
+    mudsys.add_cmd_check(cmd, chk_can_manip)
diff -ruN ../nakedmudv3.7.9/lib/pymodules/cmd_misc.py lib/pymodules/cmd_misc.py
--- ../nakedmudv3.7.9/lib/pymodules/cmd_misc.py	2009-03-02 01:45:15.000000000 -0500
+++ lib/pymodules/cmd_misc.py	2009-04-05 13:48:31.000000000 -0400
@@ -1,14 +1,10 @@
-################################################################################
-#
-# cmd_misc.c
-#
-# a collection of miscellaneous commands that come with NakedMud(tm)
-#
-################################################################################
-from mud import *
-from hooks import *
-from mudsys import add_cmd, add_cmd_check
-import event, mudsys
+'''
+cmd_misc.c
+
+a collection of miscellaneous commands that come with NakedMud(tm)
+'''
+import mudsys, mud, hooks, event, mudsys
+
 
 
 def cmd_stop(ch, cmd, arg):
@@ -38,7 +34,7 @@
        Will make you say \'hello, world!\' two seconds after entering the
        delayed command.'''
     try:
-        secs, to_delay = parse_args(ch, True, cmd, arg, "double string")
+        secs, to_delay = mud.parse_args(ch, True, cmd, arg, "double string")
     except: return
 
     if secs < 1:
@@ -62,7 +58,7 @@
 
 def cmd_quit(ch, cmd, arg):
     '''Attempts to save and log out of the game.'''
-    log_string(ch.name + " has left the game.")
+    mud.log_string(ch.name + " has left the game.")
     mudsys.do_save(ch)
     mudsys.do_quit(ch)
 
@@ -71,13 +67,13 @@
 ################################################################################
 # add our commands
 ################################################################################
-add_cmd("stop",  None, cmd_stop,  "player", False)
-add_cmd("clear", None, cmd_clear, "player", False)
-add_cmd("delay", None, cmd_delay, "player", False)
-add_cmd("motd",  None, cmd_motd,  "player", False)
-add_cmd("save",  None, cmd_save,  "player", False)
-add_cmd("quit",  None, cmd_quit,  "player", True)
+mudsys.add_cmd("stop",  None, cmd_stop,  "player", False)
+mudsys.add_cmd("clear", None, cmd_clear, "player", False)
+mudsys.add_cmd("delay", None, cmd_delay, "player", False)
+mudsys.add_cmd("motd",  None, cmd_motd,  "player", False)
+mudsys.add_cmd("save",  None, cmd_save,  "player", False)
+mudsys.add_cmd("quit",  None, cmd_quit,  "player", True)
 
 chk_can_save = lambda ch, cmd: not ch.is_npc
-add_cmd_check("save", chk_can_save)
-add_cmd_check("quit", chk_can_save)
+mudsys.add_cmd_check("save", chk_can_save)
+mudsys.add_cmd_check("quit", chk_can_save)
diff -ruN ../nakedmudv3.7.9/lib/pymodules/colour.py lib/pymodules/colour.py
--- ../nakedmudv3.7.9/lib/pymodules/colour.py	2009-03-02 01:45:15.000000000 -0500
+++ lib/pymodules/colour.py	2009-04-05 13:50:43.000000000 -0400
@@ -42,6 +42,8 @@
 # colour processing hooks
 ################################################################################
 def process_colour_hook(info):
+    """When outbound text is being processed, find colour codes and replace them
+       by the proper colour escape sequences."""
     sock,  = hooks.parse_info(info)
     buf    = sock.outbound_text
     newbuf = []
diff -ruN ../nakedmudv3.7.9/lib/pymodules/display.py lib/pymodules/display.py
--- ../nakedmudv3.7.9/lib/pymodules/display.py	1969-12-31 19:00:00.000000000 -0500
+++ lib/pymodules/display.py	2009-04-05 14:06:45.000000000 -0400
@@ -0,0 +1,164 @@
+'''
+display.py
+
+Various utilities for displaying information such as tables and metered values.
+'''
+import math, mud
+
+
+
+def table_row(info, align="left", caps = "|", space=" ",
+              center_filler=" ", width=79):
+    '''display a table row like this:
+       | info       |
+       '''
+    # account for color codes
+    width += info.count("{")*2
+
+    fmt = "%s%s%%-%ds%s%s" % (caps, space, width-len(caps)*2-len(space)*2,
+                              space, caps)
+    if align == "center":
+        info = info.center(width-len(caps)*2-len(space)*2, center_filler)
+    elif align == "right":
+        fmt = "%s%s%%%ds%s%s" % (caps, space, width-len(caps)*2-len(space)*2,
+                                 space, caps)
+    return fmt % info
+
+def table_splitrow(left, right, align="left", caps = "|", space=" ",
+                   center_filler=" ", width=79):
+    '''display two columns like this:
+       | left    | right    |
+       '''
+    width -= len(caps)*2 + len(space)*4
+    linfo = table_row(left,  align, "", "", center_filler, width/2)
+    rinfo = table_row(right, align, "", "", center_filler, width/2)
+    fmt = "%s%s%%s%s%s%s%%s%s%s" % (caps,space,space,caps,space,space,caps)
+    return fmt % (linfo, rinfo)
+
+def table_splitrows(left, right, align="left", caps = "|", space=" ",
+                   center_filler=" ", width=79):
+    """return a list of split rows"""
+    buf = [ ]
+    for i in range(max(len(left), len(right))):
+        lstr = ""
+        rstr = ""
+        if i < len(left):
+            lstr = left[i]
+        if i < len(right):
+            rstr = right[i]
+        buf.append(table_splitrow(lstr, rstr, align, caps, space, center_filler,
+                                  width))
+    return buf
+
+def meter(val,char="{p#",empty=" ",lcap="[",rcap="]",align="left",width=20):
+    """Return a horizontal meter representing a numeric value ranging between
+       [0,1]."""
+    width   = width-len(lcap)-len(rcap) + (lcap.count("{")+rcap.count("{"))*2
+    hatches = int(math.floor(width*abs(val)))
+    hatches = min(hatches, width)
+    left    = ""
+    right   = ""
+    
+    # are we dealing with a backwards meter?
+    left  = "".join([char for v in range(hatches)])
+    right = "".join([empty for v in range(width-hatches)])
+    if align == "right":
+        left, right = right, left
+    return lcap + "{n" + left + right + "{n" + rcap + "{n"
+
+def pagedlist(category_map, order=None, header=None, height=21):
+    """Display lists of information as flips within a book. category_map is a
+       mapping between section headers and lists of entries to display for that
+       category. If you are only displaying one category, have a map from
+       the section header, Topics, to your list of entries. If the categories
+       should be displayed in a specific (or partially specific) order, that
+       can be specified. Header is text that can appear at front of the book
+       display.
+    """
+    buf = [ ]
+    
+    # split our header into rows if we have one
+    hrows = [ ]
+    if header != None:
+        hrows = mud.format_string(header, False, 76).strip().split("\r\n")
+
+    # build our full list of orderings
+    if order == None:
+        order = [ ]
+    for category in category_map.iterkeys():
+        if not category in order:
+            order.append(category)
+
+    # build our page entries. This includes categories and category items
+    entries = [ ]
+    for category in order:
+        if not category in category_map:
+            continue
+
+        # add a space between categories
+        if len(entries) > 0:
+            entries.append("")
+        entries.append(category.capitalize())
+        for item in category_map[category]:
+            entries.append("  %s" % item)
+
+    # append our header if we have one
+    if len(hrows) > 0:
+        buf.append(table_border)
+        for hrow in hrows:
+            buf.append(table_row(hrow))
+
+    # build our page contents, one page at a time, until we are out of entries
+    pages    = [ ]
+    last_cat = None
+    while len(entries) > 0:
+        page = [ ]
+        plen = height - 2 # minus 2 for the borders
+
+        # we're still on the first flip of the book; header is displayed
+        if len(pages) <= 2:
+            plen -= len(hrows) + 1 # plus 1 for the row above it
+
+        # add items to the page until we are full
+        while len(entries) > 0 and len(page) < plen:
+            entry = entries.pop(0)
+
+            # is this a blank row, and are we at the head of the page?
+            if entry == "" and len(page) == 0:
+                continue
+            
+            # is this a category header?
+            if not entry.startswith(" "):
+                last_cat = entry
+
+            # are we continuing an old category?
+            if entry.startswith(" ") and len(page)==0 and last_cat != None:
+                page.append("%s (cont.)" % last_cat)
+            page.append(entry)
+
+        # did we have anything added to it?
+        if len(page) > 0:
+            pages.append(page)
+
+    # take our pages by twos and turn them into table rows
+    i = 0
+    while i < len(pages):
+        page1 = pages[i]
+        page2 = [ ]
+        if i+1 < len(pages):
+            page2 = pages[i+1]
+
+        # append the rows and page contents
+        buf.append(table_border)
+        buf.extend(table_splitrows(page1, page2))
+        buf.append(table_border)
+        i += 2
+    
+    buf.append("")
+    return buf
+
+# shortcut table elements
+table_border = table_row("", "center", "+", "", "-")
+table_filler = table_row("")
+seperator    = table_row("", "center", "-", "", "-")
+
diff -ruN ../nakedmudv3.7.9/lib/pymodules/doc.py lib/pymodules/doc.py
--- ../nakedmudv3.7.9/lib/pymodules/doc.py	1969-12-31 19:00:00.000000000 -0500
+++ lib/pymodules/doc.py	2009-04-05 03:09:50.000000000 -0400
@@ -0,0 +1,129 @@
+"""
+doc.py
+
+This module allows documentation for Python classes and modules to be viewed
+in-game via the 'doc' command. 
+"""
+import pydoc, os, mudsys, display
+
+
+
+################################################################################
+# local variables
+################################################################################
+
+# where do we store documentation?
+HTML_DOC_DIR = "../html/pydocs"
+
+shortcuts = { "ch"      : "char",
+              "sock"    : "mudsock",
+              }
+
+# just a list of all our builtin modules
+builtins = [
+    "char",
+    "room",
+    "obj",
+    "exit",
+    "account",
+    "mudsock",
+    "mud",
+    "mudsys",
+    "hooks",
+    "event",
+    "auxiliary",
+    "storage",
+    "olc",
+    ]
+
+# append all of our builtins to suggested reading list
+suggested_reading = [mod for mod in builtins]
+
+def register_module_doc(modname, package = None, root = "pymodules"):
+    """Add a new module name to suggested_reading. If modname is a package,
+       recursively add its packages as well
+    """
+    fname = root + "/" + modname.replace(".", "/")
+    suggested_reading.append(modname)
+    if os.path.isdir(fname):
+        for file in os.listdir(fname):
+            if (file.endswith(".py") or not "." in file) and not file[0] in "._":
+                module = modname + "." + file.split(".", 1)[0]
+                register_module_doc(module, root)
+ 
+# now, append all of our Python packages and modules
+for fname in os.listdir("pymodules/"):
+    # look for modules and packages
+    if (fname.endswith(".py") or not "." in fname) and not fname[0] in "._":
+        modname = fname.split(".", 1)[0]
+        register_module_doc(modname)
+
+
+
+################################################################################
+# player commands
+################################################################################
+def cmd_htmldoc(ch, cmd, arg):
+    """Creates html documentation for all registered modules. html files will
+       be saved to html/pydocs/
+    """
+    try:
+        os.makedirs(HTML_DOC_DIR)
+    except: pass
+    doc = pydoc.HTMLDoc()
+    for modname in suggested_reading:
+        todoc = pydoc.locate(modname)
+        if todoc != None:
+            fname = HTML_DOC_DIR + "/" + modname + ".html"
+            fl    = file(fname, "w+")
+            fl.write(doc.page(modname, doc.document(todoc)))
+            fl.close()
+
+    builtin_index = doc.multicolumn([doc.modulelink(pydoc.locate(modname)) for modname in builtins], lambda x: x)
+    
+    # build our index page. That includes things in pymodules/ and builtins
+    index_contents ="".join([doc.section("<big><strong>builtins</big></strong>",
+                                         'white', '#ee77aa', builtin_index),
+                             doc.index("../lib/pymodules/")])
+
+    # go over all of our builtins and add them to the index
+    index = file(HTML_DOC_DIR + "/index.html", "w+")
+    index.write(doc.page("index", index_contents))
+    index.close()
+    
+    ch.send("html documentation generated for all known modules.")
+
+def cmd_doc(ch, cmd, arg):
+    """Return Python documentation for the specified module, class, function,
+       etc... for example:
+       
+       > doc char.Char
+
+       Will return all available documentation for the Char class.
+    """
+    if arg == "":
+        ch.page("\r\n".join(display.pagedlist({ "Topics" : suggested_reading },
+                                              header = "Suggested doc readings include:")))
+    else:
+        # just because sometimes I forget periods
+        arg = arg.replace(" ", ".")
+
+        # are we looking for a shortcut value?
+        if arg in shortcuts:
+            arg = shortcuts[arg]
+
+        # try to find what we're documenting
+        todoc = pydoc.locate(arg)
+        if todoc == None:
+            ch.send("Could not find Python documentation on: '%s'" % arg)
+        else:
+            doc = pydoc.TextDoc()
+            ch.page(doc.document(todoc).replace("{", "{{"))
+
+
+
+################################################################################
+# initialization
+################################################################################
+mudsys.add_cmd("doc",     None, cmd_doc,     "wizard", False)
+mudsys.add_cmd("htmldoc", None, cmd_htmldoc, "admin",  False)
